#!/usr/bin/php -q
<?php
  $idTag = '$Id: populateFlatFile.php,v 1.1 2007/01/30 23:36:53 ianbezanson Exp $';
  $vers = '$Revision: 1.1 $';
  $opt = getopt("u:f:b:hvr");
  if(array_key_exists('h', $opt) || (!array_key_exists('r', $opt) && !array_key_exists('v', $opt)))
  { 
?>

#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
# $Id: populateFlatFile.php,v 1.1 2007/01/30 23:36:53 ianbezanson Exp $
#
# As the name suggests, this will populate a flatfile with data from your 
# uploads directory, and is really only necessary after an upgrade from 
# DropBox v0.0.1Beta
#
# Usage: <?php echo $_SERVER['argv'][0]; ?> <option>
#
#  -h                          to get this help.
#  -v                          to return the version of this file.
#  -r                          to run the script (should be at the end).
#  -b [/path/to/dropbox/]      to define the base directory of dropbox install.
#  -f [fileData.dat]           to define the flat file.
#  -u [uploads/]               to define uploads directory.
#
# At least the '-r' flag are required to run this script (albeit, with default
# values).  Without that flag, you will be bounced back to this help page.
# Only set the values that differ.
#
################################################################################

<?php
    exit;
    break;
  }
  elseif(array_key_exists('v', $opt))
  {
    echo "$idTag\n$vers\n";
    exit;
    break;
  }
  elseif(array_key_exists('r', $opt))
  {
    if(array_key_exists('b', $opt)) $basedir = $opt['b'];
    else $basedir = '/path/to/dropbox/';
    if(array_key_exists('f', $opt)) $flatfile = $opt['f'];
    else $flatfile = 'fileData.dat';
    if(array_key_exists('u', $opt)) $uploads = $opt['u'];
    else $uploads = 'uploads/';

    $uploads = $basedir.$uploads;
    $flatfile = $basedir.$flatfile;

    // Open a known directory, and proceed to read its contents
    if (is_dir($uploads))
    {
      if ($dh = opendir($uploads))
      {
        $count = 0;
        while (($file = readdir($dh)) !== false)
        {
          if ($file != '.' && $file != '..')
          {
            $filesize = GetReadableFileSize($uploads . $file);
            echo "Path: [$uploads]\n";
            echo "Filename: [$file]\n";
            echo "Filesize: [$filesize]\n";
            fwrite(STDOUT, "Enter username for file owner: ");
            $owner = trim(fgets(STDIN));
            fwrite(STDOUT, "Would you like this file to be viewable to all users(yes/no)? ");
            $public = trim(fgets(STDIN));
            echo "\n";
            $toFlatFile[$count] = "$file||$filesize||$owner||$public||\n";
            $count++;
          }
        }
        closedir($dh);
      }
    }
    
    $handle = fopen($flatfile, "w+");
    if ($handle)
    {
      foreach($toFlatFile as $value)
      {
        fwrite($handle, $value);
      }
    }
    fclose($handle);
  }

  function GetReadableFileSize($path)
  {
    $filesize = filesize($path);
    $unit = "bytes";
    if ($filesize > 1024)
    {
      $filesize = ($filesize / 1024);
      $unit = "kB";
    }
    if ($filesize > 1024)
    {
      $filesize = ($filesize / 1024);
      $unit = "MB";
    }
    if ($filesize > 1024)
    {
      $filesize = ($filesize / 1024);
      $unit = "GB";
    }
    if ($filesize > 1024)
    {
      $filesize = ($filesize / 1024);
      $unit = "TB";
    }

    $filesize = round($filesize, 2);
    return $filesize." ".$unit;
  }

?>